class Chunk{
	constructor(x,y){
		this.x = x;
		this.y = y;

		this.leftRoad = null;
		this.rightRoad = null;
		this.bottomRoad = null;
		this.topRoad = null;

		//create clan leader
		//identify location
		//assign difficulty

		var villain = new Person({isVillain: true});
		var men = util.randRange(
			3,
			2+Math.floor(game.difficultyFactor*2)
		);
		this.clan = {
			villain: villain,
			location:{
				x: this.x*CHUNK_SIZE + Math.floor(util.randRange(CHUNK_SIZE/8,7*CHUNK_SIZE/8)),
				y: this.y*CHUNK_SIZE + Math.floor(util.randRange(CHUNK_SIZE/8,7*CHUNK_SIZE/8))
			},
			revealed: false,
			name: villain.name +"'s lair",
			reputation: util.randRange(40,60),
			//todo: use difficulty
			men: men,
			startingMen: men,
			dead: false
		};

		var isCamp = this.isCamp();

		if(isCamp){
			this.clan.revealed = true;
			this.clan.name = "Refugee Camp";
			this.clan.dead = true;
		}

		this.key = x + "," + y;
		map.chunks[this.key] = this;




		//create tiles in chunk
		//look for previous roads on adjacent chunks

		for(var i=0;i<CHUNK_SIZE;i++){
			for(var j=0;j<CHUNK_SIZE;j++){
				var tile = new Tile(
					this.x*CHUNK_SIZE+i,
					this.y*CHUNK_SIZE+j,
					isCamp
				);
			}
		}

		//todo: roads	
			//get neighborkey];
			//set top/bottom/left/right (use )

		var left = this.getLeftNeighbor();
		var right = this.getRightNeighbor();
		var top = this.getTopNeighbor();
		var bottom = this.getBottomNeighbor();

		if(left && left.rightRoad){
			this.leftRoad = left.rightRoad;			
		}else{
			this.leftRoad = Math.floor(util.randRange(CHUNK_SIZE/8,7*CHUNK_SIZE/8));
		}
		if(right && right.leftRoad){
			this.rightRoad = right.leftRoad;			
		}else{
			this.rightRoad = Math.floor(util.randRange(CHUNK_SIZE/8,7*CHUNK_SIZE/8));
		}
		if(top && top.bottomRoad){
			this.topRoad = top.bottomRoad;
		}else{
			this.topRoad = Math.floor(util.randRange(CHUNK_SIZE/8,7*CHUNK_SIZE/8));
		}
		if(bottom && bottom.topRoad){
			this.bottomRoad = bottom.topRoad;
		}else{
			this.bottomRoad = Math.floor(util.randRange(CHUNK_SIZE/8,7*CHUNK_SIZE/8));
		}

		this.connect(
			0,
			this.leftRoad,
			CHUNK_SIZE-1,
			this.rightRoad
		);
		this.connect(
			this.topRoad,
			0,
			this.bottomRoad,
			CHUNK_SIZE-1
		);

		var road = false;
		for(var i=0;i<CHUNK_SIZE;i++){
			for(var j=0;j<CHUNK_SIZE;j++){
				var tile = map.tile(
					this.x*CHUNK_SIZE+i,
					this.y*CHUNK_SIZE+j
				);
				if(tile.road){
					road = true;
					var roadTile = new Tile(
						tile.x,
						tile.y,
						isCamp
					);
					//maybe?
					if(!roadTile.isCamp){
						if(roadTile.type == "tree"){
							roadTile.type = "none";
							roadTile.fortifyLevel = 0;
							roadTile.numLayers = 0;
						}
					}
					roadTile.road = true;

					if((roadTile.getLocalX() == 0 && roadTile.getLocalY()===this.leftRoad) ||
					(roadTile.getLeftNeighbor() && roadTile.getLeftNeighbor().road)){
						roadTile.roadLeft = true;
					}
					if((roadTile.getLocalX() == CHUNK_SIZE-1 && roadTile.getLocalY()===this.rightRoad) ||
					(roadTile.getRightNeighbor() && roadTile.getRightNeighbor().road)){
						roadTile.roadRight = true;
					}
					if((roadTile.getLocalY() == 0 && roadTile.getLocalX()===this.topRoad) ||
					(roadTile.getTopNeighbor() && roadTile.getTopNeighbor().road)){
						roadTile.roadTop = true;
					}
					if((roadTile.getLocalY() == CHUNK_SIZE-1 && roadTile.getLocalX()===this.bottomRoad) ||
					(roadTile.getBottomNeighbor() && roadTile.getBottomNeighbor().road)){
						roadTile.roadBottom = true;
					}
				}
			}
		}
	}

	getCoordinates(){
		var tile = map.tile(
			Math.floor(this.x*CHUNK_SIZE+CHUNK_SIZE*.5),
			Math.floor(this.y*CHUNK_SIZE+CHUNK_SIZE*.5)
		)
		return tile.getLatitude() + " " + tile.getLongitude();
	}

	isCamp(){
		return game.campChunkX == this.x && game.campChunkY == this.y;
	}

	getClanTile(){
		return map.tile(this.clan.location.x, this.clan.location.y);
	}

	getLeftNeighbor(){
		var key = (this.x-1)+","+(this.y);
		return map.chunks[key];
	}

	getRightNeighbor(){
		var key = (this.x+1)+","+(this.y);
		return map.chunks[key];
	}

	getTopNeighbor(){
		var key = (this.x)+","+(this.y-1);
		return map.chunks[key];
	}

	getBottomNeighbor(){
		var key = (this.x)+","+(this.y+1);
		return map.chunks[key];
	}

	connect(x1,y1,x2,y2){
		var timeout = 1024;
		var disChunk = this;
		var passableCallback = function(x, y){
			timeout--;
			if(timeout<0)return false;
			if(x<0||y<0||x>=CHUNK_SIZE||y>=CHUNK_SIZE) return false;
			//return true;
			return map.tile(disChunk.x*CHUNK_SIZE + x,disChunk.y*CHUNK_SIZE + y).roadable;
		}
		var astar = new ROT.Path.AStar(x1,y1, passableCallback,{topology: 4});
		var pathfind = [];
		astar.compute(x2, y2, function(x, y){
		    pathfind.push(
		    	map.tile(disChunk.x*CHUNK_SIZE + x,disChunk.y*CHUNK_SIZE + y)
		    );
		});

		for(var i=0;i<pathfind.length;i++){
			var p = pathfind[i];
			p.road = true;
		}
	}
}