events = {
	doEvent:function(dt){
		//todo: make sure actions like sleeping have higher chance of events
		var tile = camera.getTile();
		var tileZombies = tile.zombies;


		var localClan = map.getClan();
		
		var secretZombie = null;
		for(var i=0;i<game.crew.length;i++){
			if(game.crew[i].zombie){
				secretZombie = game.crew[i];
				break;
			}
		}


		if(tile.isCamp){
			game.win();
			return
		//}else if(true){
		//	return;
		}

		if(secretZombie){
			util.remove(game.crew,secretZombie);

			game.violentOutcome(true);
			if(Math.random()<.5){
				game.violentOutcome(true);
			}

			if(game.crew.length === 0){
				menu.toast(secretZombie.name+' turned into a zombie and killed everyone.');
			}else{
				clan.setClan(1, true);
				events.combat(secretZombie);
			}

			return;
		//CLAN ENCOUNTER
		//TODO: COMBAT OR TRADING depending upon reputation
		}

		if(!localClan.dead && Math.random()< map.getClanRevealChance()){
			clan.setClan(localClan.men, false);
			events.combat();
			return;
		}

		var r = Math.random();
		var zombieAmbushChance = dt*tile.getPopulationDensity()/80;
		if(game.isNight()){
			zombieAmbushChance *= 3;
		}
		if(r<zombieAmbushChance){

			/* I DON'T UNDERSTAND THIS WELL ENOUGH
			var zombieIncrease = Math.floor(dt);
			//increase zombies before attack

			if(tile.zombies == 0  && Math.random()*10<dt){
				if(!tile.isFortified()){
					tile.getAllNeighbors().forEach(function(t){
						t.setZombies();
						if(zombieIncrease>0 && t.zombies>0){
							zombieIncrease--;
							t.zombies--;
							tile.zombies++;
						}
					});
				}else{
					tile.fortifyLevel--;
					menu.toast("Zombies have destroyed some fortifications.");
				}
			}*/

			if(tileZombies > 0){
				var numZombies = util.randRange(1,tileZombies); 
				numZombies = Math.min(
					numZombies,
					Math.floor(game.difficultyFactor*2) + 1
				);
				clan.setClan(numZombies, true);
				events.combat();
			}

			return;

		}

		if(tile.people){
			events.findPeople();
			tile.people = false;
			return;
		}

		
		var r = Math.random();
		var crazyChance = dt/12;
		if(r<crazyChance){
			for(var i=0;i<game.crew.length;i++){
				var subject = game.crew[i];
				var psychotic = subject.hasTrait("Psychotic");
				var coward = subject.hasTrait("Coward"); 
				var suicidal = subject.hasTrait("Suicidal");
				var thief = subject.hasTrait("Thief");

				if(suicidal && subject.getEmotion(subject)>=80){
					subject.die("self-inflicted wounds");
					return;
				}

				if(thief){
					stash.items.pop();
					game.drawUI();
				}

				if(coward) continue;
				//HANDLE CRAZY
				for(var j=0;j<game.crew.length;j++){
					var target = game.crew[j];

					if(!subject.equals(target)){
						if(!subject.isPlayer && !subject.isOffspring){
							var emotion = subject.getEmotion(target);
							if(emotion>=80 || 
							(emotion>=50 && psychotic)){
								subject.goCrazy(target);
								return;
							}
						}
					}
				}
			}
		}
	},
	findPeople:function(){
		var race;
		if(menu.menuData.peopleList){
			var peopleList = menu.menuData.peopleList;
			var family = menu.menuData.family;
		}else{
			var numPeople = Math.random()<.5 ? 1 : util.randRange(2,3);
			if(numPeople>1){
				var family = true;
				var lastName = util.pick(game.lastNames);
				race = traits.getRace();
			}else{
				var family = false;
			}
			var peopleList = [];
			var age;
			for(var i=0;i<numPeople;i++){
				if(i==0 && Math.random()<.5){
					age = util.randRange(65,95)
				}else{
					age = undefined;
				}
				peopleList.push(people.generatePerson(lastName, race,age));
			}
			menu.menuData.family = family;
			util.shuffle(peopleList);
			menu.menuData.peopleList = peopleList;

			people.setupFamily(peopleList);
		}

		var content = "";
		if(peopleList.length === 1){
			var title = "I AIN'T GONNA MAKE IT MUCH LONGER BY MYSELF.";
		}else{
			var title = "PLEASE LET US IN. YOU DON'T KNOW WHAT IT'S LIKE OUT THERE";
		}

		content += '<table id="person-table">';
		for(var i=0;i<peopleList.length;i++){
			var person = peopleList[i];
			content += '<tr>'+
				'<td>'+person.getPreviewHtml()+'</td>';
				if(!family && game.crew.length < game.MAX_CREW){
					content += '<td>'+
						'<div class="button" button-id="take" object-id="'+person.id+'">Take in</div> '+
					'</td>';
				}
			content += '</tr>';
		}
		content += '</table>';

		content += '<div class="button-group-right">';
			content += '<div class="button" button-id="leave-all">Leave</div> ';
			if(family){
				if(game.crew.length <= game.MAX_CREW - peopleList.length){
					content += '<div class="button" button-id="take-all">Take All</div> ';
				}
				content += '<div class="button" button-id="split-up">Split up</div>';
			}
		content += '</div>';



		menu.showMenu(
			title,
			content,
			false,
			"new-people"
		);
	},
	combat:function(secretZombie){
		var haveGuns = stash.hasEquippedGuns();

		menu.menuData.startingClan = clan.count();
		menu.menuData.startingCrew = game.crew.length;

		var content = '';

		content += '<div style="min-height: 100px;">';

		if(secretZombie){
			content += '<p>'+secretZombie.name+' turned into a zombie and started attacking people.</p>';
			clan.combatText = "Oh no...";
		}else if(clan.zombie){
			content += '<p>You\'ve been ambushed by zombies.</p>';
		}else{
			var localClan = map.getClan();
			if(localClan.villain.gender === "male"){
				content += '<p>You\'re being surrounded by '+localClan.villain.name+' and his men.</p>';
			}else{
				content += '<p>You\'re being surrounded by '+localClan.villain.name+' and her men.</p>';
			}
		}

		content += '<table class="combat-table">';
		content += '<tr class="header-row">';
			content += '<td>';
				content += 'Crew ';
				content +='(<span class="crew-count">'+game.crew.length+'</span>)';

				if(stash.bullets > 0 && haveGuns){
					content += ' - '+stash.bullets+' bullet'+(stash.bullets==1?'':'s');
				}
			content += '</td>';
			content += '<td>';
				if(secretZombie){
					content += secretZombie.name+' ';
				}else if(clan.zombie){
					content += 'Zombies ';
				}else{
					content += 'Enemy ';
				}
				content +='(<span class="enemy-count">'+clan.count()+'</span>)';
			content += '</td>';
		content += '</tr>';

		content += '<tr class="attack-label-row rifle-row">';
			content += '<td>';
				content += 'Rifles: ';
			content += '</td>';
			content += '<td>';
				content += 'Rifles:';
			content += '</td>';
		content += '</tr>';

		content += '<tr class="attack-value-row rifle-row">';
			content += '<td class="crew-cell rifle-cell"></td>';
			content += '<td class="enemy-cell rifle-cell"></td>';
		content += '</tr>';

		content += '<tr class="attack-label-row handgun-row">';
			content += '<td>';
				content += 'Handguns:';
			content += '</td>';
			content += '<td>';
				content += 'Handguns:';
			content += '</td>';
		content += '</tr>';

		content += '<tr class="attack-value-row handgun-row">';
			content += '<td class="crew-cell handgun-cell"></td>';
			content += '<td class="enemy-cell handgun-cell"></td>';
		content += '</tr>';

		content += '<tr class="attack-label-row long-reach-row">';
			content += '<td>';
				content += 'Long reach melee:';
			content += '</td>';
			content += '<td>';
				content += 'Long reach melee:';
			content += '</td>';
		content += '</tr>';

		content += '<tr class="attack-value-row long-reach-row">';
			content += '<td class="crew-cell long-reach-cell"></td>';
			content += '<td class="enemy-cell long-reach-cell"></td>';
		content += '</tr>';

		content += '<tr class="attack-label-row short-reach-row">';
			content += '<td>';
				content += 'Short reach melee:';
			content += '</td>';
			content += '<td>';
				content += 'Short reach melee:';
			content += '</td>';
		content += '</tr>';

		content += '<tr class="attack-value-row short-reach-row">';
			content += '<td class="crew-cell short-reach-cell"></td>';
			content += '<td class="enemy-cell short-reach-cell"></td>';
		content += '</tr>';

		content += '<tr class="attack-label-row outcome-row">';
			content += '<td>';
				content += 'Losses:';
			content += '</td>';
			content += '<td>';
				content += 'Losses:';
			content += '</td>';
		content += '</tr>';

		content += '<tr class="outcome-result-row outcome-row">';
			content += '<td class="crew-cell outcome-cell"></td>';
			content += '<td class="enemy-cell outcome-cell"></td>';
		content += '</tr>';

		content += '</table>'


		content += '<div class="combat-buttons">'

		if(stash.bullets > 0 && haveGuns){
			content += '<div class="button" button-id="use-ranged">Use guns</div> ';
			content += '<div class="button" button-id="use-melee">Don\'t use guns</div> ';
		}else{
			content += '<div class="button" button-id="use-melee">Fight</div> ';
		}
		content += '<div class="button" button-id="escape">Escape';
		content += ' (<span id="escape-chance">'+Math.ceil(people.getEscapeChance()*100)+'</span>%)';
		content += '</div> ';
		if(!clan.zombie && stash.items.length>0){
			content += '<div class="button" button-id="give-up">Give up spare items</div> ';
		}
		content += '</div>';

		content += '<div class="combat-over-text"></div>';
		content += '<div class="combat-over-buttons">';
			content += '<div class="button ok-button" button-id="ok-button">OK</div> ';
		content += '</div>';

		content += '</div>';

		var speaker;

		if(!clan.zombie){
			var localClan = map.getClan();
			speaker = localClan.villain;
		}

		menu.showMenu(
			clan.combatText,
			'<div style="min-height: 450px;">'+content+'</div>',
			false,
			"combat",
			speaker
		);
	},
	combatHandler:function(){
		$(".crew-count").html(game.crew.length);
		$(".enemy-count").html(clan.list.length);

		if(clan.count()<=0){
			if(!clan.zombie){
				var localClan = map.getClan();
				localClan.dead = true;
			}

			if(events.combatPhase <= 4){
				events.combatPhase = 4;
			}else{
				if(clan.zombie){
					camera.getTile().zombies -= (menu.menuData.startingClan-clan.count());
				}
				$(".combat-over-buttons").show();
				$(".combat-over-text").html("It's over.").show();

				//items!
				if(clan.zombie){
					camera.getTile().getItems(menu.menuData.startingClan);
				}

				return;
			}
		}

		//alert('use guns '+menu.menuData.guns);

		var delay = 200;

		//rifle
		if(events.combatPhase === 0){
			var crewPower = stash.getRiflePower();
			var enemyPower = clan.getRiflePower();
			var row = ".rifle-row";
			var weaponType = "rifle";

			if(crewPower>0 || enemyPower>0){
				camera.getTile().increaseZombies();
			}
		//handgun
		}else if(events.combatPhase === 1){
			var crewPower = stash.getHandgunPower();
			var enemyPower = clan.getHandgunPower();
			var row = ".handgun-row";
			var weaponType = "handgun";
		//long
		}else if(events.combatPhase === 2){
			var crewPower = stash.getLongReachPower();
			var enemyPower = clan.getLongReachPower();
			var row = ".long-reach-row";
			var weaponType = "bat";
		//melee
		}else if(events.combatPhase === 3){
			var crewPower = stash.getShortReachPower();
			var enemyPower = clan.getShortReachPower();
			var row = ".short-reach-row";
			var weaponType = "knife";
		//outcome
		}else if(events.combatPhase === 4){
			//todo: bitten and dead
			var crewOutcome = (menu.menuData.startingCrew-game.crew.length)+" dead";
			var enemyOutcome = (menu.menuData.startingClan-clan.count())+" dead";
			var row = ".outcome-row";
			delay = 200;
		}else if(events.combatPhase === 5){
			$("#escape-chance").html(Math.ceil(people.getEscapeChance()*100));
			$(".combat-buttons").show();
		}

		//TODO: if ranged and power for clan/enemy is > 0, bring Zombies to tile

		if(events.combatPhase > -1 && events.combatPhase < 5){
			if(events.combatPhase === 4){
				$(row+" .crew-cell").html(crewOutcome);
				$(row+" .enemy-cell").html(enemyOutcome);
			}else{
				$(row+" .crew-cell").html(util.repeat("*",crewPower));
				$(row+" .enemy-cell").html(util.repeat("*",enemyPower));
			}
			$(row).show();
		}

		//VIOLENCE
		if(events.combatPhase > -1 && events.combatPhase < 4){
			clan.kill(crewPower);

			while(enemyPower>=1 && game.crew.length > 0){
				game.violentOutcome(clan.zombie, weaponType);

				enemyPower--;
			}
		}

		game.drawUI();


		if( events.combatPhase < 5){
			events.combatPhase++;

			if(game.state === "running"){
				setTimeout(events.combatHandler, delay);
			}
		}
	}
}