input = {
	keys:{
		37: 'LEFT ARROW',
		38: 'UP ARROW',
		39: 'RIGHT ARROW',
		40: 'DOWN ARROW',
		36: 'UP LEFT ARROW',
		33: 'UP RIGHT ARROW',
		34: 'DOWN RIGHT ARROW',
		35: 'DOWN LEFT ARROW',
		12: 'MIDDLE NUMPAD',
		27: 'ESCAPE'
	},
	init: function(){
		$("html").keypress(function(e){
			var k=e.which;

			var character = String.fromCharCode(k).toUpperCase();
			input.handleCommand(character);
		});
		$("html").keydown(function(e){
			var k=e.which;

			if(k in input.keys){
				input.handleCommand(input.keys[k]);
			}
		});
		$("#webgl,#overlay").mousemove(function(e){
			game.setHoverTile(e.clientX-$("#webgl").offset().left,e.clientY-$("#webgl").offset().top);
		});

		$("html").click(function(e){
			if(game.hoverTile != null){
				var dist = util.distance(game.hoverTile.x, game.hoverTile.y, camera.getTile().x, camera.getTile().y);
				if(dist >0 && dist < 2){
					game.tryMove(
						game.hoverTile.x - camera.getTile().x,
						game.hoverTile.y - camera.getTile().y
					);
				}
			}
		});

		$("body").on("click",".button",input.buttonHandler);

		$("#title").on("click", function(){
			startGame();
		});

		$("#toaster-container").hover(function(){
			menu.toastHover = true;
		},function(){
			menu.toastHover = false;
		});
	},
	handleCommand:function(char){
		if(!menu.menuOpen && game.state === "running"){
			game.closeSidebarDetail();
			switch(char){
				case 'W':
				case  '8':
				case 'UP ARROW':
					game.tryMove(0,-1);
					break;
				case 'A':
				case  '4':
				case 'LEFT ARROW':
					game.tryMove(-1,0);
					break;
				case 'S':
				case  '2':
				case 'DOWN ARROW':
					game.tryMove(0,1);
					break;
				case 'D':
				case  '6':
				case 'RIGHT ARROW':
					game.tryMove(1,0);
					break;
				case 'UP LEFT ARROW':
				case '7':
					game.tryMove(-1,-1);
					break;
				case 'UP RIGHT ARROW':
				case '9':
					game.tryMove(1,-1);
					break;
				case 'DOWN RIGHT ARROW':
				case '3':
					game.tryMove(1,1);
					break;
				case 'DOWN LEFT ARROW':
				case '1':
					game.tryMove(-1,1);
					break;
				case '~':
				case '`':
					uglyMode = !uglyMode;
					window.requestAnimationFrame(draw);
					break;
				case ' ':
				case '5':
				case 'MIDDLE NUMPAD':
					camera.getTile().scavenge();
					break;
			}
		}
	},
	buttonHandler:function(e){
		e.preventDefault();
		e.stopPropagation();
		if(input.hasAttr(e,"object-id")){
			var objectId = input.attr(e,"object-id");
			var obj = game.objects[objectId];
		}else{
			var objectId = null;
			var obj = null;
		}

		if(game.state === "game-over" || game.state === "won"){
			switch(e.currentTarget.attributes["button-id"].value){
				case "new-game":
					titleScreen();
					break;
			}
		}else if(game.state === "running"){
			switch(e.currentTarget.attributes["button-id"].value){
				case "crew-button":
					$(".stash-button").removeClass("active");
					$(".crew-button").addClass("active");
					$(".person-button").removeClass("active");
					people.renderCrew();
					game.tab = "crew";
					break;
				case "stash-button":
					$(".person-button").removeClass("active");
					stash.render();
					game.tab = "stash";
					break;
				case "person":
					$(".person-button").removeClass("active");
					$(e.currentTarget).addClass("active");

					people.renderPerson(obj);

					break;
				case "leave-all":
					//PREJUDICED PEOPLE WILL LIKE YOU
					for(var i=0;i<game.crew.length;i++){
						for(var j=0;j<menu.menuData.peopleList.length;j++){
							var oldCrew = game.crew[i];
							var newCrew = menu.menuData.peopleList[j];
							if(oldCrew.hates(newCrew)){
								people.emotionMod(oldCrew,game.crew[0],-5, true);
							}
						}
					}

					menu.closeMenu();
					break;
				case "take":
					if(menu.menuData && menu.menuData.peopleList){
						//PREJUDICED PEOPLE WILL HATE YOU
						var newCrew = obj;
						for(var i=0;i<game.crew.length;i++){
							var oldCrew = game.crew[i];
							if(oldCrew.hates(newCrew)){
								people.emotionMod(oldCrew,game.crew[0],10, true);
							}
						}

						util.remove(menu.menuData.peopleList, newCrew);
						game.crew.push(newCrew);
						if(menu.menuData.peopleList.length===0){
							menu.closeMenu();
						}else{
							events.findPeople();
						}
					}
					break;
				case "take-all":
					if(menu.menuData && menu.menuData.peopleList){
						//PREJUDICED PEOPLE WILL HATE YOU
						for(var i=0;i<game.crew.length;i++){
							for(var j=0;j<menu.menuData.peopleList.length;j++){
								var oldCrew = game.crew[i];
								var newCrew = menu.menuData.peopleList[j];
								if(oldCrew.hates(newCrew)){
									people.emotionMod(oldCrew,game.crew[0],10, true);
								}
							}
						}

						game.crew = game.crew.concat(menu.menuData.peopleList);
						menu.closeMenu();
					}
					break;
				case "split-up":
					menu.menuData.family = false;
					menu.menuData.peopleList;
					events.findPeople();
					for(var i=0;i<menu.menuData.peopleList.length;i++){
						var familyMember = menu.menuData.peopleList[i];

						//TODO: WILL CHANGING TO TRUE FIX THE DUPE ISSUE? IF SO DO IT!
						people.emotionMod(familyMember,game.crew[0],20, false, menu.menuData.peopleList);
					}
					break;
				case "close-detail":
					$(".person-button").removeClass("active");
					game.closeSidebarDetail();
					break;
				case "use-ranged":
					$(".rifle-row, .handgun-row, .long-reach-row, .short-reach-row, .outcome-row").hide();
					menu.menuData.guns = true;
					events.combatPhase = -1;
					$(".combat-buttons").hide();
					events.combatHandler();
					break;
				case "use-melee":
					$(".rifle-row, .handgun-row, .long-reach-row, .short-reach-row, .outcome-row").hide();
					menu.menuData.guns = false;
					events.combatPhase = -1;
					$(".combat-buttons").hide();
					events.combatHandler();
					break;
				case "escape":
					var escapeChance = people.getEscapeChance();

					var slowest = people.getSlowestPerson()

					if(Math.random()>escapeChance){
						menu.toast('Not everyone made it out.');

						//save your kid
						if(slowest.isOffspring && game.crew[0].equals(game.player)){
							slowest = game.player;
						}

						//no escape
						slowest.die();

						//let's try to take one more
						if(game.crew.length > 1 && Math.random()>escapeChance){
							slowest = people.getSlowestPerson();
	
							//save your kid
							if(slowest.isOffspring && game.crew[0].equals(game.player)){
								slowest = game.player;
							}

							slowest.die();
						}
					}else{
						menu.toast('Everyone escaped safely.');
					}

					if(clan.zombie){
						camera.getTile().zombies -= (menu.menuData.startingClan-clan.count());
					}

					menu.closeMenu();

					break;
				//TILE ACTIONS
				case "scavenge":
					camera.getTile().scavenge();

					break;
				case "ok-button":
					menu.closeMenu();
					break;
				case "give-item":
					stash.render();
					break;
				case "fully-equip":
					if(game.sidebarPerson != null){
						game.sidebarPerson.fullyEquip();
						stash.render();
						break;
					}
				case "give-up":
					while(stash.items.length>0){
						var item = stash.items.pop();
						menu.toast("Gave up your "+item.name);
					}
					menu.closeMenu();
					break;
				case "use-item":
					if(obj.targetsPerson){
						if(game.sidebarPerson != null){
							if(obj.canEquip()){
								var equipped = game.sidebarPerson.equipItem(obj);
								if(equipped){
									people.emotionMod(game.sidebarPerson,game.crew[0], -3, true);
								}
							}else{
								if(obj.use(game.sidebarPerson)){
									stash.removeItem(obj);
								}else{
									if(obj.name == "First Aid Kit"){
										menu.toast("This first aid kit can be reused.");
									}else{
										menu.toast("They don't want that.");
									}
								}
							}
						}else{
							menu.toast("First, select a person.");
							people.renderPerson(game.crew[0]);
						}
					}else{
						if(obj.use()){
							stash.removeItem(obj);
						}
					}
					break;
				case "remove-item":
					if(game.sidebarPerson != null){
						game.sidebarPerson.removeItem(obj);
						people.emotionMod(game.sidebarPerson,game.crew[0],5, true);
					}
					break;
				case "amputate":
					if(game.sidebarPerson != null){
						if(obj.bitten){
							people.emotionMod(game.sidebarPerson,game.crew[0],10, true);
						}else{
							people.emotionMod(game.sidebarPerson,game.crew[0],40);
						}
						obj.amputate(game.sidebarPerson);
					}
					break;
				case "previous-person":
					for(var i=0;i<game.crew.length;i++){
						if(game.crew[i].equals(game.sidebarPerson)){
							i--;
							if(i<0) i = game.crew.length-1;
							people.renderPerson(game.crew[i]);
							break;
						}
					}
					break;
				case "next-person":
					for(var i=0;i<game.crew.length;i++){
						if(game.crew[i].equals(game.sidebarPerson)){
							i++;
							if(i>=game.crew.length) i = 0;
							people.renderPerson(game.crew[i]);
							break;
						}
					}
					break;
				case "feed":
					if(stash.foodScrap < game.crew.length){
						menu.toast("Not enough food scrap to feed everyone.");
					}else{
						menu.toast("Crew fed.");
						for(var i=0;i<game.crew.length;i++){
							if(game.crew[i].hasTrait("Picky Eater")){
								menu.toast("But "+game.crew[i].name +" refuses to eat.");
							}else{
								game.crew[i].satiety += 10;
								stash.foodScrap--;
							}
						}
						game.tick(.5);
					}
					break;
				case "clear":
					var tile = camera.getTile();
					if(tile.zombies === 0){
						menu.toast("There are no zombies here.");
					}else{
						var numCleared = Math.min(tile.zombies, game.crew.length*2);

						tile.zombies -= numCleared;

						menu.toast("Everyone pitches in and together disposes of "+numCleared+" zombies.");

						game.tick(1);
					}
					break;
				case "exile":
					if(obj.isOffspring){
						menu.toast("You can't bear the thought.");
					}else{
						obj.exile();
					}
					break;
				case "sleep":
					if(!camera.getTile().isFortified() || camera.getTile().zombies > 0 || game.awakeDuration()<10){
						menu.toast("You can only sleep after being up for 10 hours and in an area with no zombies and at least 2 fortifications.")
					}else{
						camera.getTile().fortifyLevel--;
						menu.toast("While you slept, zombies destroyed some fortifications.");
						game.tick(9, true);
					}
					break;
				case "fortify":
					if(stash.woodScrap < 1){
						menu.toast("You need wood scrap to fortify.")
					}else{
						camera.getTile().fortifyLevel++;
						if(people.crewHasTrait("Carpentry")){
							camera.getTile().fortifyLevel++;
						}
						stash.woodScrap--;
						menu.toast("You barricade your location.");
						var dt = 1+6/(game.crew.length+2);
						game.tick(dt);
					}
					break;
				case "kill":
					if(obj.isOffspring){
						menu.toast("You can't bear the thought.");
					}else{
						obj.kill();
					}
					break;
			}
			game.drawUI();
		}
	},
	hasAttr:function(e,id){
		if(e.currentTarget.attributes[id]){
			return true;
		}else{
			return false;
		}
	},
	attr:function(e, id){
		return e.currentTarget.attributes[id].value
	}
}