class Item{
	constructor(){
		this.equippable = false;
		this.usable = false;
		this.name = "";
		this.description = "";
		this.slotCount = 1;
		this.additionalSlotTypes = [];

		this.targetsPerson = true;

		this.broken = false;
		//todo: broken items!

		this.id = ++game.globalCounter;
		game.objects[this.id] = this;
	}

	putInStash(){
		stash.items.push(this);
	}

	canEquip(){
		return this.equippable;
	}

	canUse(){
		return this.usable;
	}

	getName(){
		return this.name;
	}

	use(){
		//todo: do it
	}

	equals(obj){
		return this.id === obj.id;
	}

	getWeaponPower(person){
		//todo: specialties

		return this.weaponPower;
	}
}

class ItemKnife extends Item{
	constructor(){
		super();
		this.equippable = true;
		this.slotType = "weapon";

		this.weaponType = "short-reach-melee";

		this.name = util.pick([
			"Knife",
			"Ice pick",
			"Letter opener"
		]);

		this.weaponPower = 1;
	}
	//TODO: CODE BEHAVIOR
}
class ItemBaseballBat extends Item{
	constructor(){
		super();
		this.equippable = true;
		this.slotType = "weapon";
		this.slotCount = 2;

		this.weaponType = "long-reach-melee";

		this.name = util.pick([
			"Baseball bat",
			"Sledgehammer",
			"2x4",
			"Rebar",
			"Shovel",
			"Golf club"
		]);

		this.weaponPower = 1;
	}
	//TODO: CODE BEHAVIOR
}
class ItemHandgun extends Item{
	constructor(){
		super();
		this.equippable = true;
		this.slotType = "weapon";

		this.weaponType = "short-reach-gun";

		this.name = util.pick([
			"Handgun",
			"Pistol"
		]);

		this.weaponPower = 2;
	}
	//TODO: CODE BEHAVIOR
}
class ItemRifle extends Item{
	constructor(){
		super();
		this.equippable = true;
		this.slotType = "weapon";
		this.slotCount = 2;

		this.weaponType = "long-reach-gun";

		this.name = "Rifle";

		this.weaponPower = 3;
	}
	//TODO: CODE BEHAVIOR
}
class ItemHockeyMask extends Item{
	constructor(){
		super();
		this.equippable = true;
		this.slotType = "head";

		this.name = util.pick([
			"Hockey mask",
			"Baseball helmet",
			"Motorcycle helmet",
			"Welding helmet",
			"Horse head mask"
		]);
	}
	//TODO: CODE BEHAVIOR
}
class ItemLeatherJacket extends Item{
	constructor(){
		super();
		this.equippable = true;
		this.additionalSlotTypes = ["arm"];
		this.slotType = "torso";

		this.name = util.pick([
			"Leather jacket",
			"Heavy coat"
		]);
	}
	//TODO: CODE BEHAVIOR
}
class ItemGloves extends Item{
	constructor(){
		super();
		this.equippable = true;
		this.slotType = "hand";
		this.additionalSlotTypes = ["hand"];
		this.slotCount = 1;

		this.name = util.pick([
			"Winter gloves",
			"Rubber gloves",
			"Driving gloves",
			"Oven mitts"
		]);
	}
	//TODO: CODE BEHAVIOR
}
class ItemPants extends Item{
	constructor(){
		super();
		this.equippable = true;
		this.slotType = "leg";
		this.additionalSlotTypes = ["leg"];
		this.slotCount = 1;

		this.name = util.pick([
			"Leather pants",
			"Jeans",
			"Snow pants"
		]);
	}
}
class ItemBoots extends Item{
	constructor(){
		super();
		this.equippable = true;
		this.slotType = "foot";
		this.additionalSlotTypes = ["foot"];
		this.slotCount = 1;

		this.name = util.pick([
			"Boots",
			"Sneakers",
			"Leather shoes"
		]);
	}
	//TODO: CODE BEHAVIOR
}

class ItemFood extends Item{
	constructor(){
		super();
		this.name =util.pick([
			"Cookies",
			"Candy Bar",
			"Potato Chips",
			"Trail Mix",
			"Chocolate",
			"Dried fruit",
			"Peanut Butter"
		]);
	}

	use(person){
		person.satiety += 10;
		people.emotionMod(person,game.crew[0],-20);
		return true;
	}
}

class ItemPorn extends Item{
	constructor(){
		super();
		this.name =util.pick([
			'Adult Magazines'
		]);
	}

	use(person){
		if(person.hasTrait("Porn addict")){
			people.emotionMod(person,game.crew[0],-50);
			return true;
		}else{
			return false;
		}
	}
}

class ItemBooze extends Item{
	constructor(){
		super();
		this.name =util.pick([
			'Gin',
			'Scotch',
			'Wine',
			'Vodka',
			'Case of beer'
		]);
	}

	use(person){
		if(person.hasTrait("Alcoholic")){
			people.emotionMod(person,game.crew[0],-50);
			return true;
		}else{
			return false;
		}
	}
}

class ItemPainkillers extends Item{
	constructor(){
		super();
		this.name =util.pick([
			'Painkillers'
		]);
	}

	use(person){
		if(person.hasTrait("Narcotics addict")){
			people.emotionMod(person,game.crew[0],-50);
			return true;
		}else{
			return false;
		}
	}
}

class ItemPreparedFood extends Item{
	constructor(){
		super();
		this.name =util.pick([
			"Stew",
			"Casserole",
			"Soup",
			"Stir Fry",
			"Mystery Meatballs"
		]);
	}

	use(person){
		person.satiety += 20;
		people.emotionMod(person,game.crew[0],-10);
		return true;
	}
}

class ItemFirstAidKit extends Item{
	constructor(){
		super();
		this.name = "First Aid Kit";
	}

	use(person){
		for(var k=person.traits.length-1;k>=0;k--){
			if(person.traits[k].name == "Bleeding"){
				menu.toast(person.name + " is no longer bleeding.");
				person.traits.splice(k,1);
			}
		}
		people.emotionMod(person,game.crew[0],-20);

		if(people.crewHasTrait("First Aid")){
			return false;
		}

		return true;
	}
}

class ItemAntibiotics extends Item{
	constructor(){
		super();
		this.name = "Antibiotics";
	}

	use(person){
		for(var k=person.traits.length-1;k>=0;k--){
			if(person.traits[k].name == "Infection"){
				menu.toast(person.name + " is no longer infected.");
				person.traits.splice(k,1);
			}
		}
		people.emotionMod(person,game.crew[0],-20);
		return true;
	}
}

class ItemRadio extends Item{
	constructor(){
		super();
		this.equippable = false;
		this.usable = true;
		this.name = "Radio";

		this.targetsPerson = false;
	}

	use(){
		var content = "";

		content += "<p>"+map.getCampChunk().getCoordinates()+"</p>";

		content += "<p>Our camp is made up of both ex-military and civilians and we have space for more survivors. This is not a joke. We HAVE supplies. We CAN protect you.</p>";
		content += '<div class="button ok-button" button-id="ok-button">OK</div>';

		menu.showMenu(
			"If anyone is listening go to the these coordinates...",
			content,
			false,
			"radio"
		);

		return false;
	}
}

class ItemStackable extends Item{
	constructor(){
		super();

		this.equippable = false;

		this.count = 1;

		this.stashName = "";
	}

	getName(){
		return this.name + " (x"+this.count+")";
	}

	putInStash(){
		if(stash[this.stashName] == undefined){
			alert('invalid stash name')
		}else{
			stash[this.stashName] += this.count;
		}
	}
}
class ItemBullets extends ItemStackable{
	constructor(){
		super();
		this.count = util.randRange(5,25);
		this.name = "Bullets";
		this.stashName = "bullets";
	}
}
class ItemGas extends ItemStackable{
	constructor(){
		super();
		this.count = util.randRange(8,15);
		this.name = "Gas";
		this.stashName = "gas";
	}
}
class ItemFoodScrap extends ItemStackable{
	constructor(){
		super();
		this.count = util.randRange(5,15);
		this.name = "Food scrap";
		this.stashName = "foodScrap";
	}
}
class ItemWoodScrap extends ItemStackable{
	constructor(){
		super();
		this.count = util.randRange(2,5);
		this.name = "Wood scrap";
		this.stashName = "woodScrap";
	}
}

/*
Hammer
Rifle (two hands)
Handgun

Ammo

Baseball bat (two hands)
Radio
Find location of other camps
First aid kit

Shoes
Helmet
Hockey mask
Gloves
Jacket
Pants
Luxuries
Booze
Porn
Narcotics

BULLETS
GAS
SCRAP
	METAL
	WOOD
	FOOD
	CLOTHING
	ELECTRONICS

*/

items = {

}