var req = require.context("../../app/img/", true, /.*/);
dataUrls = {};

var files = req.keys();

files.forEach (function (file) {
  var componentId   = req.resolve(file);
  var component     =  __webpack_require__(componentId);
	dataUrls["../../app/img"+file.substr(1)] = component;
});

finishLoading = function(){
	for(var i=0;i<treeLayers.length;i++){
		var layer = treeLayers[i];
		if(layer){
			layer.sprite = PIXI.Sprite.fromImage(dataUrls[layer.path]); 
		}
	}
	for(var i=0;i<buildingLayers.length;i++){
		var layer = buildingLayers[i];
		if(layer){
			layer.sprite = PIXI.Sprite.fromImage(dataUrls[layer.path]); 
		}
	}
	for(var i=0;i<imageFiles.length;i++){
		//var img = images[imageFiles[i]];
		//img.sprite = new PIXI.Sprite(resources[img.path].texture);
	}

	game.selectorSprite = PIXI.Sprite.fromImage(dataUrls[images["selector"].path]);
	overlayStage.addChild(game.selectorSprite);

	loaded = true;
	checkLoaded();
	//window.requestAnimationFrame(draw);
}

window.titleScreen = function(){
	initOptions = {};
	initOptions.lastName = util.pick(game.lastNames),
	initOptions.offspringGender = game.randomGender(),
	initOptions.offspringName = game.getName(initOptions.offspringGender, initOptions.lastName);
	var firstName = initOptions.offspringName.split(" ")[0];

	map.init();
	game.init();
	camera.init();
	camera.getTile().explore();
	window.requestAnimationFrame(draw);

	if(game.debug){
		$("#loading").hide();
		startGame();
		return;
	}

	game.state = "title";

	$("#title h1").html("");
	var gameName = "Dead and in Denial";
	var gameName = "ZURVIVORS";
	gameName = gameName.toUpperCase();
	for(var i=0;i<gameName.length;i++){
		var span = $(
			'<span>'+gameName[i]+'</span>'
		);

		var fadeDuration = util.randRange(1400,3500);
		if(i==0){
			fadeDuration = 3000;
		}

		setTimeout((function(span){
			return function(){
				span.addClass("title-animate");
			}
		})(span), fadeDuration);
		$("#title h1").append(span);
	}

	$("#title-notes div").css({opacity:0});
	$("#notes1").html("I have to find somewhere safe for me and "+firstName+".");
	$("#notes3").html("These monsters will tear "+(initOptions.offspringGender=="male"?"him":"her")+" apart.");
	setTimeout(function(){$("#notes1").animate({opacity:1},700);},0);
	setTimeout(function(){$("#notes2").animate({opacity:1},700);},400);
	setTimeout(function(){$("#notes3").animate({opacity:1},700);},1700);
	setTimeout(function(){$("#notes4").animate({opacity:1},900);},2500);


	$("#title").show();
	$("#loading").hide();
}

checkLoaded = function(){
	if(isLoaded()){
		titleScreen();
	}
}

isLoaded = function(){
	return loaded && textLoaded === 3;
}

treeLayers = [];
buildingLayers = [];

uglyMode = false;

loadLayers =function(id, type){
	var layerIndex;
	var numTypeLayers;
	if(type === "building"){
		numLayers = numBuildingLayers[id];
		numTypeLayers = 100;
		layers = buildingLayers;
		layerIndex = 100*id + i; 
	}else{
		numLayers = numTreeLayers;
		numTypeLayers = 50;
		layers = treeLayers;
	}



	for(var i=0;i<=numLayers;i++){
		layerIndex = (numTypeLayers+1)*id + i;
		if(i === numLayers){
			var path = "../../app/img/"+type+"/"+id+"/flat.png";
		}else{
			var path = "../../app/img/"+type+"/"+id+"/layer"+i+".png";
		}
		
		//dataUrls[path] = require(path);

		layers[layerIndex]={path: path};
		//PIXI.loader.add(path);
	}
}
	

function resizeHandler(){
	var w = $(window).width();
	var h = $(window).height();

	canvasTileWidth = 9;
	canvasTileHeight = 9

	var tileSizeX = w/canvasTileWidth;
	var tileSizeY = h/canvasTileHeight;

	camera.tileSize = Math.min(tileSizeX,tileSizeY);

	canvasWidth = camera.tileSize*canvasTileWidth;
	canvasHeight = camera.tileSize*canvasTileHeight;
	
	$("#overlay,#webgl,#canvas-container").attr("width",canvasWidth);
	$("#overlay,#webgl,#canvas-container").attr("height",canvasHeight);
	
	$("#overlay,#webgl").css({
		width: canvasWidth + 'px',
		height: canvasHeight + 'px'
	});

	var type = "WebGL"
	if(!PIXI.utils.isWebGLSupported()){
	  type = "canvas"
	}
	renderer = PIXI.autoDetectRenderer(canvasWidth, canvasHeight,
		{view: document.getElementById("webgl"),antialias: false}
	);
	stage = new PIXI.Container();
	renderer.backgroundColor = 0;

	overlayRenderer = PIXI.autoDetectRenderer(canvasWidth, canvasHeight,
		{view: document.getElementById("overlay"),antialias: false, transparent: true}
	);
	overlayStage = new PIXI.Container();
	if(game.selectorSprite){
		overlayStage.addChild(game.selectorSprite);
	}

	bigRenderer = PIXI.autoDetectRenderer(350, 500,
		{view: document.getElementById("big"),antialias: false, transparent: true}
	);
	bigStage = new PIXI.Container();
	bigRenderer.render(bigStage);
}
	

window.startGame = function(){

	game.closeSidebarDetail();
	menu.closeMenu();
	$(".toaster").hide();
	menu.toastList = [];


	$("#title").fadeOut();

	game.state = "running";
	game.previousBig = null;
	//prevent flash of red
	bigStage.removeChildren();
	bigRenderer.render(bigStage);

	window.requestAnimationFrame(draw);
	window.requestAnimationFrame(drawBig);

	game.drawUI();
}


window.draw = function(){
	map.draw();
}

function drawBig(){
	if(game.state === "running" && game.hoverTile){
		if(game.previousBig === null || !game.previousBig.equals(game.hoverTile)){
			game.previousBig = game.hoverTile;
			bigStage.removeChildren();
		}
		game.hoverTile.drawBig();
		game.drawNearby();
	}else{
		bigStage.removeChildren();
	}
	bigRenderer.render(bigStage);
	window.requestAnimationFrame(drawBig);
}



$(function(){
	//ctx.imageSmoothingEnabled = false;

	//require.context(".", true, /.*/);

	//require("../style.css");
	//require("./test.js");
	//require("./items.js");


	game.firstNames = require("../../app/text/firstNames.txt").split("\r\n");;
	game.lastNames = require("../../app/text/lastNames.txt").split("\r\n");;
	game.villains = require("../../app/text/villains.txt").split("\r\n");;






	
	$(window).resize(resizeHandler);
	resizeHandler(true);

	numTreeLayers = 50;
	numBuildingLayers = [
		96,
		59,
		10,
		17,
		30
	];

	CHUNK_SIZE = 12;

	imageFiles = [
		"water",
		"dirt",
		"selector",
		"outline",
		"grass",
		"roadtop",
		"roadleft",
		"roadright",
		"roadbottom",
		"star",
		"walk",
		"drive"
	];

	images = {};

	for(var i=0;i<imageFiles.length;i++){
		var path = "../../app/img/"+imageFiles[i]+".png";

		//dataUrls[path] = require(path);

		images[imageFiles[i]] = {
			path: path
		};
		//PIXI.loader.add(path);
	}

	numTreeBundles = 2;
	for(var i=0;i<numTreeBundles;i++){
		loadLayers(i, "tree");
	}
	numBuildingBundles = 5;
	for(var i=0;i<numBuildingBundles;i++){
		loadLayers(i, "building");
	}

	textLoaded  = 0;
	



	loaded = false;
	//PIXI.loader.load(finishLoading);
	finishLoading();

	input.init();

	titleScreen();
});