map = {
	init: function(){
		map.tiles = {};
		map.chunks = {};
		//generate some basic tiles according to something
	},
	//gets a tile, but creates one if it doesn't exist
	tile:function(x,y){
		var key = x + "," + y;
		if(key in map.tiles){
			return map.tiles[key];
		}else{
			var chunk = new Chunk(
				Math.floor(x/CHUNK_SIZE),
				Math.floor(y/CHUNK_SIZE)
			);

			//tile should be made now
			return map.tiles[key];
		}
	},
	chunk:function(x,y){
		//x = Math.floor(x/CHUNK_SIZE);
		//y = Math.floor(y/CHUNK_SIZE);
		var key = x + "," + y;
		if(key in map.chunks){
			return map.chunks[key];
		}else{
			var chunk = new Chunk(x,y);
			map.chunks[key] = chunk;
			return chunk;
		}
	},
	getCampChunk:function(){
		return map.chunk(
			game.campChunkX,
			game.campChunkY
		);
	},
	getClan:function(){
		return camera.getTile().getChunk().clan;
	},
	getClanLocation:function(){
		return camera.getTile().getChunk().getClanTile();
	},
	getClanRevealChance:function(){
		var clanLocation = map.getClanLocation();
		var dist = util.distance(clanLocation.x, clanLocation.y, camera.x, camera.y);
		if(dist>4){
			return 0;
		}else{
			return Math.pow(0.5, dist);
		}
	},
	draw:function(){
		if(!loaded) return;

		var hour = game.getTimeOfDay()/60;
		game.timeTint = game.getTimeTint();
		game.shadowAmount = .5+5*(Math.abs(hour-12)/8);
		game.shadowAngle = Math.PI*(1+1*(hour-4)/16);
		game.shadowAlpha = .2*(1-Math.abs(hour-12)/8);
		var now = performance.now();
		//todo: smooth
		var left = camera.x - camera.centerOffsetX;
		var right = camera.x + camera.centerOffsetX;
		var top = camera.y - camera.centerOffsetY;
		var bottom = camera.y + camera.centerOffsetY;

		stage.removeChildren();

		//ctx.clearRect(0,0,canvasWidth, canvasHeight);


		for(var k=0;k<100;k++){
			for(var i=left;i<=right;i++){
				for(var j=top;j<=bottom;j++){
					var tile = map.tile(i,j);
					tile.setSprites();
					if(k==0){
						tile.drawGround();
					}
					tile.draw(k);
					if(k==99){
						tile.drawIcons();
					}
				}
			}
		}

		//stage.addChild(images["grass"].sprite);
		renderer.render(stage);

		console.log("draw",(performance.now()-now)/1000);
	}
}