people = {
	renderCrew:function(){
		var html = "";

		html += 'Speed: '+people.getCrewSpeed();

		for(var i=0;i<game.crew.length;i++){
			var p = game.crew[i];
			html += p.getButtonHtml();
		}
		$("#sidebar-inner").html(html);
	},
	crewHasTrait:function(traitName){
		for(var i=0;i<game.crew.length;i++){
			if(game.crew[i].hasTrait(traitName)){
				return true;
			}
		}
		return false;
	},
	getEscapeChance:function(){
		var combinedSize = Math.floor(clan.count()/2+game.crew.length);
		var chance = Math.pow(.98, combinedSize);

		if(game.isDriving()){
			chance = 1-(1-chance)/2;
		}else{
			if(game.isNight()){
				chance *= .666;
			}
			chance *= this.getCrewSpeed() / 10;
		}

		return Math.ceil(chance*100)/100;
	},
	getCrewSpeed:function(){
		if(game.crew.length==0) return 0;
		
		var speed = 99999;
		for(var i=0;i<game.crew.length;i++){
			var personSpeed = game.crew[i].getSpeed();
			if(personSpeed < speed){
				speed = personSpeed;
			}
		}
		return speed;
	},
	getSlowestPerson:function(){
		var speed = 99999;
		var slowestPerson = game.crew[0];
		for(var i=0;i<game.crew.length;i++){
			var personSpeed = game.crew[i].getSpeed();
			if(personSpeed < speed){
				speed = personSpeed;
				slowestPerson = game.crew[i];
			}
		}
		return slowestPerson;
	},
	renderPerson:function(person){
		game.sidebarPerson = person;
		var html = person.getPreviewHtml(true);

		$("#sidebar-detail-header").html(html);

		/*******************************************/

		html = "";

		html += person.getEmotionHtml();

		$("#sidebar-detail-inner1").html(html);

		/*******************************************/

		html = "";

		html += '<table class="slots-table">';
		html += '<tr><td colspan="3"><h4>Equipment</h4></td></tr>';
		var slots = person.findExistingSlots();
		for(var i=0;i<slots.length;i++){
			html += slots[i].getHtml();
		}
		html += '</table>';

		$("#sidebar-detail-inner2").html(html);


		$("#sidebar-detail").css({display: 'inline-block'});
	},
	generatePerson: function(lastName, race, age){
		var gender, fullName;
		if(lastName && Math.random()<.8){
			gender = game.randomGender();
			fullName = game.getName(gender, lastName);
		}
		return new Person({gender:gender, name: fullName, race: race, age:age});
	},
	setupFamily:function(family){
		for(var i=0;i<family.length;i++){
			var subject = family[i];
			for(var j=0;j<family.length;j++){
				var target = family[j];
				if(!subject.equals(target)){
					subject.emotions[target.id] = util.randRange(0,30);
				}
			}
		}
	},
	emotionMod:function(subject, target, change, secondOrder, list, secondOrderOnly){
		//these people can't feel shit
		if(change < 0
		&& (subject.hasTrait("Porn addict") ||
		subject.hasTrait("Alcoholic") ||
		subject.hasTrait("Narcotics addict"))){
			change *= .333;
		}


		if(!target || subject.pc || subject.equals(target)){
			return;
		}

		if(list === undefined){
			list = game.crew;
		}
		
		//changes an emotion

		if(!secondOrderOnly){
			var emotion = subject.getEmotion(target);
			subject.emotions[target.id] = emotion+change;
			
			//feel the same about self
			subject.emotions[subject.id] = subject.getEmotion(subject)+change;

			var targetName = target.name;
			if(target.isPlayer){
				targetName = '<strong>you</strong>';
			}else if(target.isOffspring){
				targetName = '<strong>your child</strong>';
			}

			if(change > 0){
				menu.toast(subject.name+' <span class="bad-color">DISLIKES</span> '+targetName+'.');
			}else{
				menu.toast(subject.name+' <span class="good-color">LIKES</span> '+targetName+'.');
			}
		}


		if(!secondOrder){
			for(var i=0;i<list.length;i++){
				if(!list[i].equals(target) && !list[i].equals(subject)){
					//the target is HATED/LOVED by someone else
					//that other person has an emotional reaction
					//for hatred, the opposite of the target's emotion

					/* e.g. C hacks off a limb of A.
							A hates C for the hacking.
							B hates A.
							B *likes* C for the hacking

							C hacks off a limb of A.
							A hates C for the hacking.
							B likes A.
							B *hates* C for the hacking
					*/
					var secondaryEmotion = list[i].getEmotion(subject);
					//meh??... if(secondaryEmotion > 60 || secondaryEmotion < 40){}
					var secondaryChange = change * (1/2) * (50 - secondaryEmotion)/50;

					if(secondaryEmotion>60 || secondaryEmotion<40){
						people.emotionMod(list[i], target, secondaryChange, true, list);
					}
				}
			}
		}
	}
}