stash = {
	stackables: [
		"bullets",
		"gas",
		"foodScrap",
		"woodScrap"
	],
	init:function(){
		for(var i=0;i<stash.stackables.length;i++){
			stash[stash.stackables[i]] = 0;
		}
		stash.items = [];

		//stash.items = [new ItemRadio()];
		stash.items = [new ItemFood()];

		/*stash.items.push(new ItemGloves());
		stash.items.push(new ItemBoots());
		stash.items.push(new ItemPants());

		stash.items.push(new ItemPorn());
		stash.items.push(new ItemBooze());
		stash.items.push(new ItemPainkillers());

		stash.items.push(new ItemPorn());
		stash.items.push(new ItemBooze());
		stash.items.push(new ItemPainkillers());

		stash.items.push(new ItemAntibiotics());
		stash.items.push(new ItemAntibiotics());
		stash.items.push(new ItemFirstAidKit());

		stash.items = [new ItemRifle(), new ItemHandgun(), new ItemKnife()];*/


		//stash.items = [new ItemFirstAidKit()];

		stash.foodScrap = util.randRange(3,5);
		stash.bullets = util.randRange(2,5);
		stash.gas = util.randRange(7,14);
		stash.woodScrap = 0;

		//stash.gas = 300;
	},
	removeItem:function(item){
		util.remove(stash.items,item);
	},
	addItem:function(item){
		stash.items.push(item);
	},
	render:function(text){
		if(text === undefined){
			text = "";
		}

		game.tab = "stash";
		$(".crew-button").removeClass("active");
		$(".stash-button").addClass("active");

		var html = "";
		html += "<p>"+text+"</p>";

		html += '<table class="stackables-table">';
		html += '<tr><td>Bullets:</td><td>'+stash.bullets+'</td></tr>';
		html += '<tr><td>Gas:</td><td>'+stash.gas+'</td></tr>';
		html += '<tr><td>Food scrap:</td><td>'+stash.foodScrap+'</td></tr>';
		html += '<tr><td>Wood scrap:</td><td>'+stash.woodScrap+'</td></tr>';
		html += '</table>';

		for(var i=0;i<stash.items.length;i++){
			var item = stash.items[i];
			html += '<div class="button item-button" button-id="use-item" object-id="'+item.id+'">'+item.name+'</div>';
		}

		$("#sidebar-inner").html(html);
	},
	generateItems:function(tile, numPeople){
		if(tile.isClanLocation() && tile.getClan().dead){
			var numTries = 10;
		}else if(numPeople){
			var numTries = Math.ceil(numPeople/2);
		}else{
			var numTries = tile.getPopulationDensity();
		}

		var items = [];

		for(var i=0;i<numTries;i++){
			if(Math.random()<.4){
				items.push(stash.generateItem(tile));
			}
		}

		if(Math.random()<.2 && people.crewHasTrait("First Aid")){
			items.push(new ItemFirstAidKit());
		}

		if(Math.random()<.2 && people.crewHasTrait("Medicine")){
			items.push(new ItemAntibiotics());
		}

		//FOOD
		if(Math.random()<.2 && camera.getTile().type != "building" && people.crewHasTrait("Hunting")){
			items.push(new ItemFoodScrap());
		}
		if(Math.random()<.2 && camera.getTile().type != "building" && people.crewHasTrait("Fishing")){
			items.push(new ItemFoodScrap());
		}
		if(Math.random()<.2 && camera.getTile().type != "building" && people.crewHasTrait("Trapping")){
			items.push(new ItemFoodScrap());
		}
		if(Math.random()<.2 && camera.getTile().type != "building" && people.crewHasTrait("Foraging")){
			items.push(new ItemFoodScrap());
		}
		if(Math.random()<.2 && camera.getTile().type == "building" && people.crewHasTrait("Cooking")){
			items.push(new ItemPreparedFood());
		}

		if(Math.random()<.2 && camera.getTile().type == "building" && people.crewHasTrait("Firearm Repair")){
			if(Math.random()<.5){
				items.push(new ItemRifle());
			}else{
				items.push(new ItemHandgun());
			}
		}


		//generate at least one item
		if(numTries>=8 && items.length == 0){
			items.push(stash.generateItem(tile));
		}

		return items;
	},
	getItemChances:function(tile){
		var itemChances = [
			[20,ItemKnife],		
			[20,ItemBaseballBat],
			[15,ItemHandgun],
			[15,ItemRifle],
			[10,ItemHockeyMask],
			[15,ItemLeatherJacket],
			[10,ItemGloves],
			[10,ItemPants],
			[40,ItemBullets],
			[5,ItemRadio],
			[10,ItemGas],
			[20,ItemFoodScrap],
			[5,ItemFood],
			[3,ItemPreparedFood],
			[5,ItemWoodScrap],
			[3,ItemFirstAidKit],
			[10,ItemBoots],
			[3, ItemPorn],
			[3, ItemBooze],
			[3, ItemPainkillers],
			[3, ItemAntibiotics]
		];

		//THIS DUMB
		var KNIFE = 		0,
			BASEBALLBAT = 	1,
			HANDGUN = 		2,
			RIFLE = 		3,
			HOCKEYMASK = 	4,
			LEATHERJACKET = 5,
			GLOVES = 		6,
			PANTS = 		7,
			BULLETS = 		8,
			RADIO = 		9,
			GAS = 			10,
			FOODSCRAP = 	11,
			FOOD = 			12,
			PREPAREDFOOD = 	13,
			WOODSCRAP	=	14,
			FIRSTAID	=	15,
			BOOTS = 		16,
			PORN = 			17,
			BOOZE =			18,
			PAINKILLERS = 	19,
			ANTIBIOTICS = 	20;

		if(tile.road){
			itemChances[GAS][0] = 80;
		}else if(tile.type == "tree"){
			itemChances[FOODSCRAP][0] = 50;
			itemChances[WOODSCRAP][0] = 100;
			itemChances[PORN][0] = 50;
		}else if(tile.type == "building"){
			if(tile.subtype == 0){ 			//city
				itemChances[HANDGUN][0] = 20;
				itemChances[PAINKILLERS][0] = 10;
				itemChances[ANTIBIOTICS][0] = 50;
			}else if(tile.subtype == 1){	//town
				itemChances[RADIO][0] = 10;
				itemChances[ANTIBIOTICS][0] = 50;
			}else if(tile.subtype == 2){	//suburbs
				itemChances[HOCKEYMASK][0] = 30;
				itemChances[BASEBALLBAT][0] = 30;
			}else{							//rural
				itemChances[RIFLE][0] = 30;
				itemChances[WOODSCRAP][0] = 15;
				itemChances[BOOZE][0] = 10;
				itemChances[PORN][0] = 10;
			}

			itemChances[FOOD][0] = 20;
			itemChances[PREPAREDFOOD][0] = 15;
			itemChances[FIRSTAID][0] = 50;
		}else{ //field
			itemChances[FOODSCRAP][0] = 60;
			itemChances[WOODSCRAP][0] = 20;
		}
		
		return itemChances;
	},
	generateItem:function(tile){
		var itemChances = stash.getItemChances(tile);
		var totalChances = 0;
		for(var i=0;i<itemChances.length;i++){
			totalChances += itemChances[i][0];
		}

		var r = Math.random()*totalChances;
		var t = 0;
		for(var i=0;i<itemChances.length;i++){
			t += itemChances[i][0];
			if(r<=t){
				var item = itemChances[i][1];
				return new item();
			}
		}
		alert('item fail')
		//should never get here
	},
	getRiflePower : function(){
		return stash.getPower("long-reach-gun", true);
	},
	getHandgunPower : function(){
		return stash.getPower("short-reach-gun", true);
	},
	getLongReachPower : function(){
		return stash.getPower("long-reach-melee", false);
	},
	getShortReachPower : function(){
		return stash.getPower("short-reach-melee", false);
	},
	getPower:function(weaponType, useBullets){
		if(useBullets && !menu.menuData.guns){
			return 0;
		}

		var power = 0;
		for(var i=0;i<game.crew.length;i++){
			var person = game.crew[i];

			if(person.hasTrait("Coward")){
				continue;
			}

			var slots = person.findWorkingSlots();
			for(var j=0;j<slots.length;j++){
				var s = slots[j];
				if(s.item){
					if(!s.item.broken && s.item.weaponType == weaponType){
						if(useBullets){
							if(stash.bullets > 0){
								power+=1;
								//s.item.getWeaponPower(person);
								stash.bullets--;
							}
						}else{
							power+=1;
							//s.item.getWeaponPower(person);
						}

						if(person.hasTrait("Shooting") && (weaponType == "long-reach-gun" || weaponType == "short-reach-gun")){
							power+=1;
						}

						if(person.hasTrait("Knives") && (weaponType == "short-reach-melee")){
							power+=1;
						}

						//these are two handed
						if(weaponType == "long-reach-gun" || weaponType == "long-reach-melee"){
							//don't count the other hand twice!
							break;
						}
					}
				}else{
					if(s.type == "weapon"  && weaponType == "short-reach-melee"){
						power+=.5;

						if(person.hasTrait("Hand to hand combat")){
							power++;
						}
					}
				}
			}
		}
		return power;
	},
	hasEquippedGuns:function(){
		for(var i=0;i<game.crew.length;i++){
			var person = game.crew[i];
			var slots = person.findWorkingSlots();
			for(var j=0;j<slots.length;j++){
				var s = slots[j];
				if(s.item){
					if(!s.item.broken &&
					(s.item.weaponType == "long-reach-gun" || s.item.weaponType == "short-reach-gun")){
						return true;
					}
				}
			}
		}
		return false;
	}
}