class Trait{
	constructor(){
		this.display = true;
		this.known = true;
		this.bad = false;
		this.good = false;

		this.knownCounter = util.randRange(5,30);
		this.shitFan = false;
	}

	getDescription(){
		if(this.description){
			return this.description;
		}else{
			return this.name;
		}
	}

	getHtml(){
		var html = '<div class="trait ';
		if(!this.known){
			html+= "unknown-trait";
		}else if(this.bad){
			html+= "bad-trait";
		}else if(this.good){
			html+="good-trait";
		}
		html += '">';

		var debug = false;
		//var debug = true;

		if(this.known || debug){
			html += '<div>'+this.getDescription()+'</div>';
		}else{
			html += '<div class="unknown-trait">'+'???'+'</div>';
		}

		html += '</div>';
		return html;
	}
}

class TraitBleeding extends Trait{
	constructor(){
		super();
		this.shitFan = true;
		this.bad = true;
		this.name = "Bleeding";
		this.known = true;
		this.shitFanCounter = util.randRange(15,25);
	}
	shitHitFan(person){
		person.die("bleeding");
	}
}

class TraitInfection extends Trait{
	constructor(){
		super();
		this.shitFan = true;
		this.bad = true;
		this.name = "Infection";
		this.known = true;
		this.shitFanCounter = util.randRange(15,35);
	}
	shitHitFan(person){
		person.die("infection");
	}
}


class TraitGeneric extends Trait{
	constructor(name, display){
		super();

		if(this.display != undefined){
			this.display = display;
		}

		this.name = name;
	}
}

class RaceWhite extends Trait{
	constructor(){
		super();
		this.name = "White";
	}
}
class RaceBlack extends Trait{
	constructor(){
		super();
		this.name = "Black";
	}
}
class RaceHispanic extends Trait{
	constructor(){
		super();
		this.name = "Hispanic";
	}
}
class RaceAsian extends Trait{
	constructor(){
		super();
		this.name = "Asian";
	}
}
class RaceNativeAmerican extends Trait{
	constructor(){
		super();
		this.name = "Native American";
	}
}
class RaceMiddleEastern extends Trait{
	constructor(){
		super();
		this.name = "Middle Eastern";
	}
}


class TraitReligion extends Trait{
	constructor(name){
		super();
		this.known = Math.random()<.666;
		this.name = name;
	}
}

class HatesPeople extends Trait{
	constructor(person){
		super();

		this.bad = true;
		this.known = Math.random()<.666;
		this.name = "hatred";

		var r = Math.random();
		if(r<.333){
			if(person.gender === "female"){
				this.target = "male";
				this.description = "Hates men";
			}else{
				this.target = "female";
				this.description = "Hates women";
			}
		}else if(r<.666){
			var targetObj;
			this.target = person.race.name;
			while(this.target == person.race.name){
				var r = Math.random();
				if(r<.1){
					targetObj = new RaceWhite();
				}else if(r<.3){
					targetObj = new RaceBlack();
				}else if(r<.5){
					targetObj = new RaceHispanic();
				}else if(r<.7){
					targetObj = new RaceAsian();
				}else if(r<.9){
					targetObj = new RaceMiddleEastern();
				}else {
					targetObj = new RaceNativeAmerican();
				}
				this.target = targetObj.name;
			}
			this.description = "Hates "+this.target+" people";
		}else{
			var targetObj;
			var myReligion;
			if(person.religion){
				this.target = person.religion.name;
			}else{
				this.target = null;
			}
			myReligion = this.target;
			while(this.target == myReligion){
				targetObj = traits.getReligion();
				this.target = targetObj.name;
			}
			this.description = "Hates "+this.target+"s";
		}
	}
}




class BadAttribute extends Trait{
	constructor(){
		super();
		this.bad = true;
		this.known = Math.random()<.666;
	}
}

class AttributePsychotic extends BadAttribute{
	constructor(){
		super();
		this.name = "Psychotic";
	}
}
class AttributeTemper extends BadAttribute{
	constructor(){
		super();
		this.name = "Temper";
	
		//anger increases quickly
	}
}
class AttributePickyEater extends BadAttribute{
	constructor(){
		super();
		this.name = "Picky Eater";
	}
}
class AttributeLimp extends BadAttribute{
	constructor(){
		super();
		this.name = "Limp";
	}
}
class AttributePornAddict extends BadAttribute{
	constructor(){
		super();
		this.name = "Porn addict";
		
		//can only be made happy with magazines
	}
}
class AttributeAlcoholic extends BadAttribute{
	constructor(){
		super();
		this.name = "Alcoholic";

		//can only be made happy with booze
	}
}
class AttributeNarcoticsAddict extends BadAttribute{
	constructor(){
		super();
		this.name = "Narcotics addict";
		//can only be made happy with painkillers
	}
}
class AttributeCoward extends BadAttribute{
	constructor(){
		super();
		this.name = "Coward";

		//doesn't contribute fighting ability
	}
}
class AttributeDepression extends BadAttribute{
	constructor(){
		super();
		this.name = "Suicidal";

		//tends to hate self
	}
}
class AttributeIllness extends BadAttribute{
	constructor(){
		super();
		this.name = "Illness";

		//prone to randomly dying
	}
}
class AttributeThief extends BadAttribute{
	constructor(){
		super();
		this.name = "Thief";

		//takes items from group
	}
}
class AttributeHighMetabolism extends BadAttribute{
	constructor(){
		super();
		this.name = "High Metabolism";

		//hunger is doubled
	}
}
class AttributeCannibal extends BadAttribute{
	constructor(){
		super();
		this.name = "Cannibal";
		
		//will kill/eat someone instead of dying of hunger
	}
}
class AttributeNarcissist extends BadAttribute{
	constructor(){
		super();
		this.name = "Narcissist";

		//hates everyone, only likes self
	}
}
class AttributeIntrovert extends BadAttribute{
	constructor(){
		super();
		this.name = "Introvert";
		
		//slow to reveal traits
	}
}



class Skill extends Trait{
	constructor(){
		super();
		this.known = Math.random()<.8;
		this.good = true;
	}
}
class SkillMedicine extends Skill{
	constructor(){
		super();
		this.name = "Medicine";
		//TODO: FINISH BEHAVIOR

		//more likely to find antibiotics
	}
}
class SkillFirstAid extends Skill{
	constructor(){
		super();
		this.name = "First Aid";
		//reuse first aid
	}
}
class SkillSurgery extends Skill{
	constructor(){
		super();
		this.name = "Surgery";
		//TODO: FINISH BEHAVIOR

		//no infection when amputating
	}
}
class SkillElectronics extends Skill{
	constructor(){
		super();
		this.name = "Electronics";
		//TODO: FINISH BEHAVIOR

		//fix broken radio
	}
}
class SkillSewing extends Skill{
	constructor(){
		super();
		this.name = "Sewing";
		//TODO: FINISH BEHAVIOR

		//fix ripped clothing
	}
}
class SkillCooking extends Skill{
	constructor(){
		super();
		this.name = "Cooking";
		//TODO: FINISH BEHAVIOR

		//turn food scrap into prepared food
	}
}


class SkillForaging extends Skill{
	constructor(){
		super();
		this.name = "Foraging";
		//TODO: FINISH BEHAVIOR

		//33% chance to find food scrap
	}
}
class SkillFirearmRepair extends Skill{
	constructor(){
		super();
		this.name = "Firearm Repair";
		//TODO: FINISH BEHAVIOR

		//repair firearms
	}
}
class SkillShooting extends Skill{
	constructor(){
		super();
		this.name = "Shooting";
		//TODO: FINISH BEHAVIOR

		//double damage (or no misses) when shooting
	}
}
class SkillVeterinarian extends Skill{
	constructor(){
		super();
		this.name = "Veterinarian";
		
		//allows dogs to join your party
	}
}
class SkillHandToHandCombat extends Skill{
	constructor(){
		super();
		this.name = "Hand to hand combat";
		//TODO: FINISH BEHAVIOR

		//triple damage on fists
	}
}
class SkillKnives extends Skill{
	constructor(){
		super();
		this.name = "Knives";
		//TODO: FINISH BEHAVIOR

		//double damage on knives
	}
}
class SkillAutomobileRepair extends Skill{
	constructor(){
		super();
		this.name = "Automobile repair";
		//TODO: FINISH BEHAVIOR

		//if car breaks down (need to implement cars for this)
	}
}
class SkillCarpentry extends Skill{
	constructor(){
		super();
		this.name = "Carpentry";
		//TODO: FINISH BEHAVIOR

		//double fortifications
	}
}
class SkillHunting extends Skill{
	constructor(){
		super();
		this.name = "Hunting";
		//TODO: FINISH BEHAVIOR

		//get more food scrap
	}
}
class SkillFishing extends Skill{
	constructor(){
		super();
		this.name = "Fishing";
		//TODO: FINISH BEHAVIOR

		//get more food scrap
	}
}
class SkillDeception extends Skill{
	constructor(){
		super();
		this.name = "Deception";
		//TODO: FINISH BEHAVIOR

		//intimidate enemies
	}
}
class SkillNegotiation extends Skill{
	constructor(){
		super();
		this.name = "Negotiation";
		//TODO: FINISH BEHAVIOR

		//better trading
	}
}
class SkillTrapping extends Skill{
	constructor(){
		super();
		this.name = "Trapping";
		//TODO: FINISH BEHAVIOR

		//more food scrap
	}
}
class SkillCounseling extends Skill{
	constructor(){
		super();
		this.name = "Counseling";
		//TODO: FINISH BEHAVIOR

		//reduce negative emotions
	}
}
class SkillComedy extends Skill{
	constructor(){
		super();
		this.name = "Comedy";
		//TODO: FINISH BEHAVIOR

		//reduce negative emotions slightly across the board
	}
}


traits = {
	getRace: function(){
		var r = Math.random();
		if(r<.40){
			return new RaceWhite();
		}else if(r<.60){
			return new RaceBlack();
		}else if(r<.80){
			return new RaceHispanic();
		}else if(r<.90){
			return new RaceAsian();
		}else if(r<.96){
			return new RaceNativeAmerican();
		}else {
			return new RaceMiddleEastern();
		}
	},
	getReligion:function(){
		var religion = util.pick([
			"Baptist",
			"Mormon",
			"Catholic",
			"Evangelical",
			"Muslim",
			"Sikh",
			"Hindu",
			"Jew",
			"Atheist",
			"Agnostic",
			"Buddhist"	
		]);
		return new TraitReligion(religion);
	},
	getWeightedReligion(){
		if(Math.random()<.75){
			var religion = util.pick([
				"Baptist",
				"Catholic",
				"Evangelical"
			]);
		}else{
			var religion = util.pick([
				"Mormon",
				"Muslim",
				"Sikh",
				"Hindu",
				"Jew",
				"Atheist",
				"Agnostic",
				"Buddhist"
			]);
		}
		return new TraitReligion(religion);
	},
	getBadAttribute:function(){
		var attribute = util.pick([
			AttributePsychotic,
			AttributeTemper ,
			AttributePickyEater,
			AttributeLimp,
			AttributePornAddict,
			AttributeAlcoholic,
			AttributeNarcoticsAddict,
			AttributeCoward,
			AttributeDepression,
			AttributeIllness,
			AttributeThief,
			AttributeHighMetabolism,
			AttributeCannibal,
			AttributeNarcissist,
			AttributeIntrovert
		], true);
		return (new attribute());
	},
	getSkill:function(){
		var skill = util.pick([
			SkillMedicine,
			SkillFirstAid,
			SkillSurgery,
			SkillElectronics,
			SkillSewing,
			SkillCooking,
			SkillForaging,
			SkillFirearmRepair,
			SkillShooting,
			SkillVeterinarian,
			SkillHandToHandCombat,
			SkillKnives,
			SkillAutomobileRepair,
			SkillCarpentry,
			SkillHunting,
			SkillFishing,
			SkillDeception,
			SkillNegotiation,
			SkillTrapping,
			SkillCounseling,
			SkillComedy
		], true);
		return (new skill());
	}
}



		
