util = {
	randRange:function(min,max){
		return Math.floor(Math.random()*(max-min+1))+min;
	},
	distance:function(x1,y1,x2,y2){
		return Math.pow(Math.pow(x2-x1,2)+Math.pow(y2-y1,2),.5);
	},
	tileDistance:function(tileA,tileB){
		return util.distance(tileA.x,tileA.y,tileB.x,tileB.y);
	},
	pick:function(val, simple){
		var type = typeof val;

		if(Array.isArray(val)){
			if(simple){
				return val.random();
			}

			return util.pick(val.random());
		}else if(type === "object"){
			return util.pick(ROT.RNG.getWeightedValue(val));
		}else if(type === "function"){
			return util.pick(val());
		}else if(type === "string" || type === "number" || type === "boolean"){
			return val;
		}else{
			throw("invalid pick type");
		}
	},
	remove:function(arr,obj){
		for(var k=arr.length-1;k>=0;k--){
			if(arr[k].equals(obj)){
				arr.splice(k,1);
				return;
			}
		}
	},
	combineList:function(arr){
		var list = "";
		for(var i=0;i<arr.length;i++){
			if(i>0) list+=", ";
			list += arr[i];
		}
		return list;
	},
	//http://stackoverflow.com/questions/2450954/how-to-randomize-shuffle-a-javascript-array
	shuffle:function shuffle(array) {
	  var currentIndex = array.length, temporaryValue, randomIndex ;

	  // While there remain elements to shuffle...
	  while (0 !== currentIndex) {

	    // Pick a remaining element...
	    randomIndex = Math.floor(Math.random() * currentIndex);
	    currentIndex -= 1;

	    // And swap it with the current element.
	    temporaryValue = array[currentIndex];
	    array[currentIndex] = array[randomIndex];
	    array[randomIndex] = temporaryValue;
	  }

	  return array;
	},
	repeat:function(char, num){
		var text = "";
		for(var i=0;i<num;i++){
			text += char;
		}
		return text;
	}
}